[fritz2](../index.md) / [io.fritz2.routing](./index.md)

## Package io.fritz2.routing

### Types

| [MapRoute](-map-route/index.md) | [MapRoute](-map-route/index.md) marshals and unmarshals a [Map](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html) to and from *window.location.hash*. It is like using url parameters with pairs of key and value. In the begin there is only a **#** instead of **?**.`class MapRoute : `[`Route`](-route/index.md)`<`[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>` |
| [Route](-route/index.md) | A Route is a abstraction for routes which needed for routing`interface Route<T>` |
| [Router](-router/index.md) | Router register the event-listener for hashchange-event and handles route-changes. Therefore it uses a [Route](-route/index.md) object which can [Route.marshal](-route/marshal.md) and [Route.unmarshal](-route/unmarshal.md) the given type.`open class Router<T>` |
| [StringRoute](-string-route/index.md) | [StringRoute](-string-route/index.md) is a simple [Route](-route/index.md) which marshals and unmarshals nothing.`class StringRoute : `[`Route`](-route/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>` |

### Functions

| [decodeURIComponent](decode-u-r-i-component.md) | `fun decodeURIComponent(encodedURI: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) |
| [encodeURIComponent](encode-u-r-i-component.md) | `fun encodeURIComponent(decodedURI: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) |
| [router](router.md) | Creates a new simple [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) based [Router](-router/index.md)`fun router(default: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`Router`](-router/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Creates a new [Map](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html) based [Router](-router/index.md)`fun router(default: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>): `[`Router`](-router/index.md)`<`[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>`<br>Creates a new type based [Router](-router/index.md). Therefore the given type must implement the [Route](-route/index.md) interface.`fun <T> router(default: `[`Route`](-route/index.md)`<T>): `[`Router`](-router/index.md)`<T>` |
| [select](select.md) | Select return a [Pair](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html) of the value and the complete routing [Map](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html) for the given key in the [mapper](select.md#io.fritz2.routing$select(io.fritz2.routing.Router((kotlin.collections.Map((kotlin.String, )))), kotlin.String, kotlin.Function1((kotlin.Pair((kotlin.String, kotlin.collections.Map((, )))), io.fritz2.routing.select.X)))/mapper) function.`fun <X> `[`Router`](-router/index.md)`<`[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>.select(key: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, mapper: (`[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>) -> X): Flow<X>` |

